"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Assertion = void 0;

var _react = _interopRequireWildcard(require("react"));

var _TestContext = require("./TestContext");

var Assertion = function Assertion(_ref) {
  var expectFunction = _ref.expectFunction,
      method = _ref.method,
      value = _ref.value,
      _ref$verbose = _ref.verbose,
      verbose = _ref$verbose === void 0 ? false : _ref$verbose;
  var func = expectFunction[method];

  var _useContext = (0, _react.useContext)(_TestContext.TestContext),
      active = _useContext.active,
      push = _useContext.push;

  if (!func) {
    return _react["default"].createElement(_react["default"].Fragment, null, "`missing func $", method, "`");
  }

  var functionWithValue = function functionWithValue() {
    return func(value);
  };

  if (active) {
    push(functionWithValue);
  } else {
    functionWithValue();
  }

  if (!verbose) {
    return _react["default"].createElement(_react["default"].Fragment, null);
  }

  return _react["default"].createElement("li", {
    className: "assertion"
  }, method, ' ', typeof value !== 'undefined' ? _react["default"].createElement("strong", null, value.toString()) : '');
};

exports.Assertion = Assertion;