"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Expect = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _expect = _interopRequireDefault(require("expect"));

var _utility = require("../utility");

var _Assertion = require("./Assertion");

var Expect = function Expect(_ref) {
  var not = _ref.not,
      variant = _ref.variant,
      children = _ref.children,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["not", "variant", "children"]);
  var verbose = (0, _utility.useIsVerbose)();
  var expectKeys = Object.keys(props);
  var expectFunction = not ? (0, _expect["default"])(children).not : (0, _expect["default"])(children);
  var assertionList = expectKeys.map(function (key) {
    var value = (0, _utility.shouldReturnBoolean)(key, props[key]) ? props[key] : undefined;
    return _react["default"].createElement(_Assertion.Assertion, {
      verbose: verbose,
      key: key,
      method: key,
      expectFunction: expectFunction,
      value: value
    });
  });

  if (!verbose) {
    return _react["default"].createElement(_react["default"].Fragment, null, assertionList);
  }

  return _react["default"].createElement("div", {
    className: "expect"
  }, not ? 'Do not expect ' : 'Expect ', _react["default"].createElement("strong", null, typeof children === 'function' ? (0, _utility.filterFuncName)(children.toString()) : (children || '').toString(), variant ? " (variant: ".concat(variant, ")") : ''), _react["default"].createElement("ul", {
    className: "expect__list"
  }, assertionList));
};

exports.Expect = Expect;